/*----------------------------------------------------------------------*/
/* Copyright (c) 1988-1989						*/
/* by CompuServe Inc., Tucson, AZ.  All Rights Reserved			*/
/* WRITEGIF.C can be copied and distributed freely for any		*/
/* non-commercial purposes. WRITEGIF.C can only be incorporated		*/
/* into commercial software with the permission of CompuServe Inc.	*/
/*----------------------------------------------------------------------*/

/* Code file WRITEGIF.C */


#include <stdio.h>

#include "cnvhuf.h"
#include "writegif.h"

/* Prototypes */

static void process_color( rle_line	*line_record,
			   colors	run_color,
			   int		run_length );
static FILE
	*gif_file;

extern void initialize_output( file_name_string		filename )
{
   gif_file = fopen( filename, "wb" );
} /* initialize_output */

extern short put_GIF_byte( unsigned char	nxt_char )
{
    fputc( nxt_char, gif_file );
    return ferror( gif_file );
} /* put_GIF_byte */


extern void	display_line( rle_line	*line_record )
{
   int		loop_temp;
   colors	display_color; 

   /* display_line */
   {
   printf( "%s%d%s%d\n",
   		"Line(",
		scan_lines,
		") length = ",
		(*line_record).line_length);
   display_color = WHITE;
      {
      int UPPER_LIMIT3 = (*line_record).rle_count;
      for (loop_temp = 1; loop_temp <= UPPER_LIMIT3; ++loop_temp)
         {
         if (display_color == WHITE)
            printf( "%s",1,"   White");
         else 
            printf( "%s",1,"   Black");
         printf( "%s%*d\n",2," run of ",4,(*line_record).rle_list[(loop_temp)-1]);
         display_color = !(display_color);
         }
      loop_temp--;
      }
   }
}/* display_line */


extern void	finish_output()
{
   fclose( gif_file );
}/* finish_output */
